clear
%bpskfaddivM.m presihanje

close all

fc=10e3;        %nosilna frekvenca
ppf=2*pi*fc;
fs=12*fc;       %vzorna vrekvenca
ddt=1/fs;
nn=1e-3/ddt;    %tevilo vzorcev v eni milisekundi
M=2^(nextpow2(nn));
N=8;            %tevilo bitov
a=[1 1 -1 -1 -1 1 -1 1];
kp=floor(nn/8); %irina impulza
del=0.3;        %ulomljena zakasnitev 0.25 - 0.75
dd1=round(del*kp);
del2=0.56;      %druga ulomljena zakasnitev 0.25 - 0.75
dd2=round(del2*kp);
sd=0.1;         %std dev. aditivnega belega uma..0.02-0.7.
sdiv=[zeros(1,kp*8)];
mdiv=input('Vnesite red raznolikosti; 1,2,..10 or 15 >>>');
for kdiv=1:mdiv; %red raznolikosti
for ku=1:8;
for k=(ku-1)*kp+1:kp*ku
tt(k)=k*ddt;
s(k)=a(ku);      %niz impulzov
sf(k)=a(ku)*cos(ppf*tt(k));%VF impulz
sf1(k)=5*rand(1)*cos(ppf*tt(k)+2*pi*rand(1));   %signal nakljune faze, amplitude
sf2(k)=10*rand(1)*cos(ppf*tt(k)+2*pi*rand(1));  %signal nakljune faze, amplitude
end;
end;
for k=1:kp*ku;
if k<=dd1
ss1(k)=0;
else
ss1(k)=s(k-dd1);    %zakasnjeni vlak impulzov
end;
end;
for k=1:kp*ku;
tt2(k)=k*ddt;
if k<=dd2
ss2(k)=0;
else
ss2(k)=s(k-dd2);    %zakasnjeni impulz
end;
end;
suma=s+ss1+ss2;      %oblika impulzov
suma=suma/max(abs(suma));      %normalizacija
rfsum=sf+sf1.*ss1+sf2.*ss2; %dodajanje VF impulzov 
rfsum=rfsum/max(abs(rfsum));%normalizacija
for k=1:kp*8;
sfd(k)=(rfsum(k)+normrnd(0,sd))*2*cos(ppf*tt(k));   %koherenni demodulator presihajoega signala s umom
ssfd(k)=(sf(k)+normrnd(0,sd))*2*cos(ppf*tt(k));     %koherenni demodulator signala 
end;
[bb,aa]=butter(10,.2);
sfd=filtfilt(bb,aa,sfd);
ssfd=filtfilt(bb,aa,ssfd);
sdiv=sdiv+sfd;                                      %dodanjanje raznolikosti
end;
sdiv=sdiv/max(abs(sdiv));%normalize
sfd=sfd/max(abs(sfd));
ssfd=ssfd/max(abs(ssfd));
plot(tt*1e3,s,tt*1e3,sf),title('bitno zaporedje [1 1 -1 -1 -1 1 -1 1]')
ylim([-2 2]);
xlabel('cas ms')
ylabel('V')
legend('vhodni bitni niz','izhodni visokofrekvenni niz')
figure
plot(tt*1e3,suma,tt*1e3,rfsum),title('Vpliv presihanja')
ylim([-2 2]);
xlabel('time ms')
ylabel('volts')
legend('bitni niz po presihanju','VF niz po presihanju')
mmd=num2str(mdiv);
title2=strcat('Vpliv raznolikosti',' reda= ', mmd);
figure
plot(tt*1e3,s,'r',tt*1e3,ssfd,'k',tt*1e3,sfd,'g',tt*1e3,sdiv,'b'),title(title2)
legend('Podatki','demodulirani podatki - brez presihanja','demodulirani podatki - s presihanjem','raznolikost');
ylim([-2 2])
xlabel('cas ms')
ylabel('V')
for kk=1:N
ky=round(kp/2+(kk-1)*kp);
if (sum(ssfd(ky-fix(kp/2):ky+fix(kp/2))))>0   %koh. dem. s umom
b(kk)=1;
else
b(kk)=-1;
end;
if (sum(sfd(ky-fix(kp/2):ky+fix(kp/2))))>0;   %koh. dem. s presihanjem
c(kk)=1;
else
c(kk)=-1;
end;
if (sum(sdiv(ky-fix(kp/2):ky+fix(kp/2))))>0;  %%koh. dem. z uporabo raznolikosti
d(kk)=1;
else
d(kk)=-1;
end;
end;
'vhodni niz'
(a+1)/2
'izhodni niz..koherenni demodulator'
(b+1)/2
'izhodni niz..koherenni demodulator in presihanje'
(c+1)/2
'izhodni niz..koherenni demodulator in raznolikost'
(d+1)/2